#!/usr/bin/perl
#
##############################################################################
#-----------------------------------------------------------------------------
# Bismillah AlRahman Alrahem
#
# This Script is designed to display a random Hadith/Quran Verse from the attached file.
# Although this is a FREE scripts for all Islamic sites This code may not be 
# reproduced in whole or in part. Distribution or resale is strictly prohibited in 
# all circumstances. The Footer Copyrights note Can not be removed without Approval.
#
# ==================================================================
#
#   Author       : AbdoulrahmN Kattih
#   Author Email : webmaster@2muslims.com
#   Author Site  : http://www.2muslims.com/
#   Description  : Quran/Hadith Random displayer
#   Version      : 1.00
#
#   All code is FREE but copyrighted to http://www.2muslims.com/
#   To get your Free copy go to: http://www.2muslims.com/
#
#
##############################################################################
#
use strict;
use vars qw/$qurant $cfgfile $in $CFG/;
use CGI;
use CGI::Cookie;

main();
exit;

sub main{
	$qurant = "hadith.txt";
	$cfgfile = "data.txt";
	$in = new CGI;
	&load_cfg();
	if($ENV{QUERY_STRING} =~ m,admin,){
		&do_admin();
	}else{
		&do_statement();
		
	}
	
}

sub do_statement{
	my $st = "";
	my $len = scalar(@{$CFG->{data}});
	my $curtime = time;
	my $diff = $curtime - $CFG->{when};
	my $rand = int(rand($len));

	if($CFG->{type} eq 'l'){
		$st = @{$CFG->{data}}[rand($len)];
	}elsif($CFG->{type} eq 'h'){
		if($diff>86400){ $diff /= 86400;}
		if($diff > 3600){
			$CFG->{current} = $rand;
			$CFG->{when} = $curtime;
			&save_cfg;
		}
		$st = $CFG->{data}->[$CFG->{current}];
	}else{
		if($diff>86400){
			$CFG->{current} = $rand;
			$CFG->{when} = $curtime;
			&save_cfg;
		}
		$st = $CFG->{data}->[$CFG->{current}];
	}
	print $in->header;
	$st =~ s/#$//g;
	print  $st;

}
sub do_admin{
	my %cookies = fetch CGI::Cookie;
	my $title = '<p align=center>Admin Configuration</p>';
	unless($cookies{ad_random_st}){
		unless($CFG->{pass}){
			my $pass = $in->param('pass');
			
			unless($in->param('save') and $pass){
				print $in->header;	
				print qq|
					$title 
				<form method=post>
				Your new password <input  name=pass value="$pass"><br><br>
				<input type=submit name=save value="Save your password">
				</form>
				|;

			}else{
				my @salt = ('a'..'z','A'..'Z',0..9)[rand(61),rand(61)];
				my $newpass = crypt($pass,join("",@salt));
				$CFG->{pass} = $newpass;
				my $c = CGI::Cookie->new(
						-name => 'ad_random_st',
						-value => $$,
						-path => '/',
						);
				print $in->header(-cookies => $c);
	
				print "$title  Your password $newpass @salt has been saved sucessfully. Please click <a href=?admin>here</a> to continue.";
				&save_cfg;
			}
		}else{
			if($in->param('login')){
				my $pass = $in->param('pass');
				my $crypt = crypt($pass,$CFG->{pass});
				if($crypt eq $CFG->{pass}){
					my $c = CGI::Cookie->new(-name => 'ad_random_st',
						-value=> $$,
						-path => '/',
						);
					print $in->header(-cookies => $c);
					print $title . "You have logged in successfully!<br><br>";
					print "Click <a href=\"?admin\">here </a> to continue.";
					exit;
				}
			}
			print $in->header;	
			print qq|$title 
				<form method=post>
				Your password: <input  name=pass value=""><br>
				<input type=submit name=login value="Save your password">
				</form>
				|;

		}
	}else{

		print $in->header;
		unless($in->param('save')){
			
			print qq|$title 
				<form method=post>
				<input type=radio name=type value=d|;
				if($CFG->{type} eq 'd'){ print " checked ";}
				print qq|>Random Daily<br>
				<input type=radio name=type value=h|;
				if($CFG->{type} eq 'h'){ print " checked ";}
				print qq|>Random Hourly<br>
				<input type=radio name=type value=l|;
				if($CFG->{type} eq 'l'){ print " checked ";}
				print qq|>Random Everyloaded<br><br><br>
				<input type=submit name=save value="Save any changes">
				</form>
			|;
		}else{
			
			print qq|$title<p >Your changes have been saved successfully!</p>|;
			$CFG->{type} = $in->param('type');
			$CFG->{when} = time;
			$CFG->{current} = int rand(scalar(@{$CFG->{data}}));
			&save_cfg;
		}
	}
}
sub load_cfg{
	$CFG = do "$cfgfile";
	
	unless(defined $CFG){
		$CFG = {};
		$CFG->{data} = [];
		foreach(qw/pass type when current/){
			unless($CFG->{$_}){
				$CFG->{$_} = "";
			}
		}
	}
	my @data = @{$CFG->{data}};
	if($#data <0){
		local $/= undef;
		open(DB,"<$qurant") or die "Could not open file $qurant . Rason:" . $!;
		my $file = <DB>;
		close DB;
		chomp $file;
		my @commands = split(/\d+.\d+:/,$file);
		$CFG->{data} = [@commands];
		
	}
		
}
sub save_cfg{


	open(DB,">$cfgfile");
	flock(DB,2);
	print DB '{' . "\n";
	foreach(keys %$CFG){
		my $thedata =$CFG->{$_}; 
		if(ref ($CFG->{$_}) eq 'ARRAY'){
			print DB "$_ => [\n";
			foreach(@$thedata){
				next if /^\s*$/g;
				s/'/\\'/g;
				print DB "'$_',\n";
			}
			print DB "],\n";
		}else{
			print DB qq|$_ => "$thedata",\n|;
			}
	}
	print DB '};' . "\n";
	close DB;
}
sub debug{
	print $in->header;
	use Data::Dumper;
	print Data::Dumper->Dump([$_[0]]);
	exit if($_[1]);
}
